<script>
import { page } from '$app/stores';
import { socketStore } from '@/plugins/socket.js';
import Digit from '@/components/digit.svelte';
import { onDestroy } from 'svelte';
import { splitIntoDigits } from '@/plugins/utils';
import { topics } from '@/plugins/store.js';

let clicks = 0;
let unsubscribe;
$: {
    if (!unsubscribe) {
        socketStore.update(store => {
            unsubscribe = store.subscribe(message => {
                // Do something with the message here
                try {
                    let m = JSON.parse(message)
                    if (m.msg_type == "init") {
                        clicks = m.data[0].message.clicks
                    } else {
                        clicks = m.data.message.clicks;
                    }
                } catch (e) {
                    // console.log(e)
                }
            });
            return store;
        });
    }
}

// Add a topic to the socket
topics.update(store => {
    store.push("/widget/"+$page.params.streamer);
    return store;
});

socketStore.update(store => {
    store.send(JSON.stringify({"topics": $topics}));
    return store;
});

onDestroy(() => {
    unsubscribe();
    // Remove the topic from the socket
    topics.update(store => {
        store.splice(store.indexOf("/widget/"+$page.params.streamer), 1);
        return store;
    });
    socketStore.update(store => {
        store.send(JSON.stringify({"topics": $topics}));
        return store;
    });
});
</script>
  
<!-- Display a counter if  -->
<div class="text-9xl font-extrabold" style="background-color:transparent">
    <div class="grid grid-flow-col text-center auto-cols-max" style="background-color:transparent">
        {#each splitIntoDigits(clicks, 0) as count}
            <div class="flex flex-col justify-center" style="background-color:transparent">
                <Digit digit={count} />
            </div> 
        {/each}
    </div>
</div>